
let canvas;
let ctx;
let height;
let width;
let timeHolder = null;
const timeInterval = 40;
const stars = [];
function initStarField() {
    let speed = 1;
    const colors = ['#888888', '#bbbbbb', '#dddddd','#ffffff'];
    for( let i = 0; i < height; i++) {
        const star = [];
        star['x'] = parseInt( Math.random()*width );
        star['y'] = i;
        star['s'] = speed;
        star['c'] = colors[i - 1];
        stars[i] = star;
        speed++;
        if ( speed > 4 ) {
            speed = 1;
        }
    }
}
const dot = (x=1, y=1, w=1, h=1, c='#ffffff') => {
    ctx.fillStyle = c;
    ctx.fillRect(x,y,w,h);
}
const clear = () => {
    ctx.fillStyle = '#000000';
    ctx.fillRect(1, 1, width, height);
}
const interruptFunction = () => {
    clear();
    for ( let i =0; i < stars.length-1; i++) {
        dot(
            stars[i]['x'], stars[i]['y'],
            stars[i]['s'], stars[i]['s'],
            stars[i]['c']
        );
        stars[i]['x'] += stars[i]['s'];
        if ( stars[i]['x'] >= width ) {
            stars[i]['x'] = 0;
        }
    }
}

const startStarField = () => {
    canvas = document.getElementById('canvas');
    width = canvas.width;
    height = canvas.height;
    ctx = canvas.getContext("2d");
    initStarField();

    if (timeHolder !== null) {
        clearInterval( timeHolder );
    }
    timeHolder = setInterval( interruptFunction, timeInterval)
}
